<?php

global $gv_ScheduleGlobals, $gv_ScheduleDirectory, $gv_SiteGlobals, $gv_TotalWeeks, $gv_Config;

$gv_ScheduleDirectory = $gv_SiteGlobals['Paths']['FileRoot'] . $gv_SiteGlobals['Paths']['ModulesDir'] . $gv_SiteGlobals["Modules"]['Schedule'];
$gv_ScheduleGlobals = parse_ini_file($gv_ScheduleDirectory . 'schedule.ini', true);

/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	class maml_term extends prototype_tag {
	
		public $startdate;
		public $enddate;
		
		protected  $doctext = <<<'DOCBLOCK'
<p>Defines the start (and optionally end) of a "term" (as in academic term). If set can be used with <code>&lt;maml:schedule&gt;</code> and <code>&lt;maml:a&gt;</code> to set visibility relative to the term (easier to change later).</p>
<pre>Must be within &lt;maml:term&gt;&lt;/maml&gt; pair.
    Required Attribute: startdate
    Required Attribute: dateformat
    Optional Attribute: enddate
</pre>
DOCBLOCK;
	
		function begin(){
            $fv_TemplateVars['dateformat'] = strtolower($this->dateformat);
            $fv_TemplateVars['globalstartdate'] = ' startdate="'.$this->startdate.'"';  
            if($this->enddate){
                $fv_TemplateVars['globalenddate'] = ' enddate="'.$this->enddate.'"'; 
            }        

            if($fv_TemplateVars['dateformat'] === 'american'){
                //echo 'american'; exit();
                if(isset($this->startdate)){
                    //echo $this->startdate;
                    $str = $this->startdate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'m/d/Y');
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('m-d-Y',$this->startdate);
                            date_format($sdate,'m-d-Y');
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('m.d.Y',$this->startdate);
                            date_format($sdate,'m.d.Y');;
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('m d Y',$this->startdate);
                            date_format($sdate,'m d Y');
                            //$now = date_create("now");
                            break;
                        }
                    }
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'m/d/Y');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('m-d-Y',$this->enddate);
                            date_format($edate,'m-d-Y');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('m.d.Y',$this->enddate);
                            date_format($edate,'m.d.Y');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('m d Y',$this->enddate);
                            date_format($edate,'m d Y');
                            break;
                        }
                    }
                }
            }
            elseif($fv_TemplateVars['dateformat'] === 'european'){
                if(isset($this->startdate)){
                    $str = $this->startdate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'d/m/Y');
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('d-m-Y',$this->startdate);
                            date_format($sdate,'d-m-Y');
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('d.m.Y',$this->startdate);
                            date_format($sdate,'d.m.Y');
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('d m Y',$this->startdate);
                            date_format($sdate,'d m Y');
                            //$now = date_create("now");
                            break;
                        }
                    }
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'d/m/Y');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('d-m-Y',$this->enddate);
                            date_format($edate,'d-m-Y');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('d.m.Y',$this->enddate);
                            date_format($edate,'d.m.Y');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('d m Y',$this->enddate);
                            date_format($edate,'d m Y');
                            break;
                        }
                    }
                }
            }
            elseif($fv_TemplateVars['dateformat'] === 'chinese'){
                if(isset($this->startdate)){
                    $str = $this->startdate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'Y/m/d');
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('Y-m-d',$this->startdate);
                            date_format($sdate,'Y-m-d');
                            //$now = date_create("now");
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('Y.m.d',$this->startdate);
                            date_format($sdate,'Y.m.d');
                            //$now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('Y m d',$this->startdate);
                            date_format($sdate,'Y m d');
                            //$now = date_create("now");
                            break;
                        }
                    }
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'Y/m/d');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('Y-m-d',$this->enddate);
                            date_format($edate,'Y-m-d');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('Y.m.d',$this->enddate);
                            date_format($edate,'Y.m.d');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('Y m d',$this->enddate);
                            date_format($edate,'Y m d');
                            break;
                        }
                    }
                }
            }
            else{
                //$now = new Datetime("now");
                if(isset($this->startdate)){
                    $sdate = date_create($this->startdate);
                }
                if(isset($this->enddate)){
                    $edate = date_create($this->enddate);
                }
                
            }
            
            
            $interval = $sdate->diff($edate);
            global $gv_TotalWeeks;
            $gv_TotalWeeks = (int)((($interval->days) / 7)+1);
            global $gv_StartDate;
            global $gv_EndDate;
            $gv_StartDate = $sdate;
            $gv_EndDate = $edate;


        }   
        
		function end() {
		
		}
	   
    }
	
	
/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	class maml_schedule extends prototype_tag {
	   
        
		public $dateformat;      
		public $startdate;        
		public $enddate;
		public $startweek;
		public $endweek;
		public $startday;
		public $endday;
		public $permitted;
		private $passes;
		protected  $doctext = <<<'DOCBLOCK'
<p>Show content for a given period of time.
If there's a term set, <code>startweek</code>, <code>startday</code>, <code>endweek</code>, and <code>endday</code> can be used relative to the start of the term.
Regardless, <code>startdate</code> and <code>enddate</code> can be used to set an absolute date.
</p>
DOCBLOCK;

	//american m-d-y european d-m-y chinese y-m-d unix- timestamp
		function begin(){
            
            $this->startCache();
            
            global  $gv_ScheduleDirectory, $gv_StartDate, $gv_EndDate;
            
            $fv_TemplateVars['id'] = $this->id();
            $fv_TemplateVars['dateformat'] = strtolower($this->dateformat);
            if(isset($this->startdate)){
                $fv_TemplateVars['startdate'] = ' startdate="'.$this->startdate.'"'; 
            }
            else{
                $fv_TemplateVars['startdate'] ='';
            }
            if(isset($this->enddate)){
                $fv_TemplateVars['enddate'] = ' enddate="'.$this->enddate.'"'; 
            }
            else{
                $fv_TemplateVars['enddate'] ='';
            }
            if(isset($this->startweek)){
                $fv_TemplateVars['startweek'] = ' startweek="'.$this->startweek.'"'; 
            }
            else{
                $fv_TemplateVars['startweek'] = '';
            }
            if(isset($this->endweek)){
                $fv_TemplateVars['endweek'] = ' endweek="'.$this->endweek.'"';
            }
            else{
                $fv_TemplateVars['endweek'] = '';
            }
            if(isset($this->startday)){
                $fv_TemplateVars['startday'] = ' startday="'.$this->startday.'"';
            }
            else{
                $fv_TemplateVars['startday'] = '';
            }
            if(isset($this->endday)){
                $fv_TemplateVars['endday'] = ' endday="'.$this->endday.'"';
            }
            else{
                $fv_TemplateVars['endday'] = '';    
            }
            if(isset($this->permitted)){
                $fv_TemplateVars['permitted'] = ' permitted="'.$this->permitted.'"';
            }
            else{
                $fv_TemplateVars['permitted'] = '';
            }

            $monday = date_create('monday this week');
            $tuesday = date_create('tuesday this week');
            $wednesday = date_create('wednesday this week');
            $thursday = date_create('thursday this week');
            $friday = date_create('friday this week');
            $saturday = date_create('saturday this week');
            $sunday = date_create('sunday this week');
            
            if($fv_TemplateVars['dateformat'] === 'american'){
                //echo 'american'; exit();
                if(isset($this->startdate)){
                    //echo $this->startdate;
                    $str = $this->startdate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'m/d/Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('m-d-Y',$this->startdate);
                            date_format($sdate,'m-d-Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('m.d.Y',$this->startdate);
                            date_format($sdate,'m.d.Y');;
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('m d Y',$this->startdate);
                            date_format($sdate,'m d Y');
                            $now = date_create("now");
                            break;
                        }
                    }
                }
                else{
                    $sdate = date_create('now');
                    $now = date_create('now');
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'m/d/Y');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('m-d-Y',$this->enddate);
                            date_format($edate,'m-d-Y');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('m.d.Y',$this->enddate);
                            date_format($edate,'m.d.Y');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('m d Y',$this->enddate);
                            date_format($edate,'m d Y');
                            break;
                        }
                    }
                }
            }
            elseif($fv_TemplateVars['dateformat'] === 'european'){
                if(isset($this->startdate)){
                    $str = $this->startdate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'d/m/Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('d-m-Y',$this->startdate);
                            date_format($sdate,'d-m-Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('d.m.Y',$this->startdate);
                            date_format($sdate,'d.m.Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('d m Y',$this->startdate);
                            date_format($sdate,'d m Y');
                            $now = date_create("now");
                            break;
                        }
                    }
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'d/m/Y');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('d-m-Y',$this->enddate);
                            date_format($edate,'d-m-Y');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('d.m.Y',$this->enddate);
                            date_format($edate,'d.m.Y');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('d m Y',$this->enddate);
                            date_format($edate,'d m Y');
                            break;
                        }
                    }
                }
            }
            elseif($fv_TemplateVars['dateformat'] === 'chinese'){
                if(isset($this->startdate)){
                    $str = $this->startdate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'Y/m/d');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('Y-m-d',$this->startdate);
                            date_format($sdate,'Y-m-d');
                            $now = date_create("now");
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('Y.m.d',$this->startdate);
                            date_format($sdate,'Y.m.d');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('Y m d',$this->startdate);
                            date_format($sdate,'Y m d');
                            $now = date_create("now");
                            break;
                        }
                    }
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'Y/m/d');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('Y-m-d',$this->enddate);
                            date_format($edate,'Y-m-d');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('Y.m.d',$this->enddate);
                            date_format($edate,'Y.m.d');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('Y m d',$this->enddate);
                            date_format($edate,'Y m d');
                            break;
                        }
                    }
                }
            }
            else{
                $now = new Datetime("now");
                if(isset($this->startdate)){
                    $sdate = date_create($this->startdate);
                }
                if(isset($this->enddate)){
                    $edate = date_create($this->enddate);
                }
                
            }
            
            if(!($this->startdate)){
                if($gv_StartDate){
                    $sdate = $gv_StartDate;
                }
                else{
                    $sdate = date_create('now');
                    $now = date_create('now');
                }
            }
            if(!($this->enddate)){
                if($gv_EndDate){
                    $edate = $gv_EndDate;
                }
                else{
                    $edate = date_create('tomorrow');
                }
                
            }
            
            $interval2 = $now->diff($sdate);
            $CurrentWeek =0;
            $CurrentWeek = (int)((($interval2->days) / 7)+1);
            
            $interval3 = $now->diff($sdate);
            $CurrentDay = 0;
            $CurrentDay = (int)((($interval3->days))+1);
            
            if($now<$sdate){
                $CurrentWeek = $CurrentWeek * -1;
                $CurrentDay = $CurrentDay * -1;
            }
            
            $ifstartday = false;
            $ifendday = false;
            
            if($this->startday and $this->startweek){
                if($this->startday == '1'){
                    if($now > $monday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '2'){
                    if($now > $tuesday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '3'){
                    if($now >= $wednesday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '4'){
                    if($now >= $thursday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '5'){
                    if($now >= $friday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '6'){
                    if($now >= $saturday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '7'){
                    if($now >= $sunday){
                        $ifstartday = true;
                    }
                }
            }
            if($this->endday and $this->endweek){
                if($this->endday == '1'){
                    if($now >= $monday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '2'){    
                    if($now >= $tuesday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '3'){
                    if($now >= $wednesday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '4'){
                    if($now >= $thursday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '5'){
                    if($now >= $friday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '6'){
                    if($now >= $saturday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '7'){
                    if($now >= $sunday){
                        $ifendday = true;
                        return;
                    }
                }
            }
            
            if(!($this->startweek) and $this->startday and $this->startdate){
                if($CurrentDay >= (int)$this->startday){
                    $ifstartday = true;
                }
            }
            if(!($this->endweek) and $this->endday and $this->enddate){
                if($CurrentDay >= $this->endday){
                    $ifendday = true;
                }
            }            
            
            $this->passes = false;
            
            if($now){
                if(isset($this->startdate)){
                    if($now < $sdate){
                        $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.hide.tplt' );
                        return;
                    }
                }
                if(isset($this->enddate)){
                    if($now > $edate){
                        $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.hide.tplt' );
                        return;
                    }
                }
                if(isset($this->startweek)){
                   if($CurrentWeek < $this->startweek){
                        $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.hide.tplt' );
                        return;
                   }
                }
                if(isset($this->endweek)){
                    if($CurrentWeek > $this->endweek){
                        $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.hide.tplt' );
                        return;
                    }
                }
                if(isset($this->startday)){
                    if($ifstartday == false){
                        $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.hide.tplt' );
                        return;
                    }
                }
                if(isset($this->endday)){
                    if($ifendday == true){
                        $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.hide.tplt' );
                        return;
                    }
                }
                $this->passes = true;
                $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.show.tplt');
            }
            else{
               $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.begin.hide.tplt' ); 
                $this->passes = false;
            }

		}
		
		function end() {
            global  $gv_ScheduleDirectory;
			
            $this->finishCache();
            if($this->passes == true){
                echo $this->tagCache;
                $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.end.tplt', array());
            }
            else{
                $this->echoTemplate($gv_ScheduleDirectory . 'templates/schedule.end.tplt', array());
            }
		}

	
	}
	
	
/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */

	class maml_a extends prototype_tag { // extending maml_schedule rather than the usual prototype_tag class seems like
										 // a reasonable thing to do, since a lot of date calculations, etc. seem like they
										 // would be the same. If that's not the case and there's no benefit to extending
										 // maml_schedule, then by all means change this.
	
		public $showtext; //[true | false | yes | no]
		public $href;
		public $rel;
		public $target;
 		public $dateformat;
 		public $startdate;
 		public $enddate;
 		public $startweek;
 		public $endweek;
 		public $startday;
 		public $endday;
 		public $permitted;
		private $passes;
        private $notext;
		protected  $doctext = <<<'DOCBLOCK'
<p>Works exactly like <code>&lt;maml:schedule&gt;</code>, except that it takes normal <code>&lt;a&gt;</code> attributes, such as <code>href</code>.</p>
DOCBLOCK;
	
		function begin(){
            
            global  $gv_ScheduleDirectory, $gv_StartDate, $gv_EndDate;
            
            $this->startCache();
            
            $fv_TemplateVars['id'] = $this->id();
            $fv_TemplateVars['dateformat'] = strtolower($this->dateformat);
            
            if(isset($this->href)){
                $fv_TemplateVars['href'] = ' href="'.$this->href.'"';
            }
            else{
                $fv_TemplateVars['href'] = ' href = "#"';
            }
            if(isset($this->showtext)){
                $fv_TemplateVars['showtext'] = ' showtext="'.$this->showtext.'"';
            }
            else{
                $fv_TemplateVars['showtext'] = ' showtext="false"';
            }
            if(isset($this->startdate)){
                $fv_TemplateVars['startdate'] = ' startdate="'.$this->startdate.'"'; 
            }
            else{
                $fv_TemplateVars['startdate'] ='';
            }
            if(isset($this->enddate)){
                $fv_TemplateVars['enddate'] = ' enddate="'.$this->enddate.'"'; 
            }
            else{
                $fv_TemplateVars['enddate'] ='';
            }
            if(isset($this->startweek)){
                $fv_TemplateVars['startweek'] = ' startweek="'.$this->startweek.'"'; 
            }
            else{
                $fv_TemplateVars['startweek'] = '';
            }
            if(isset($this->endweek)){
                $fv_TemplateVars['endweek'] = ' endweek="'.$this->endweek.'"';
            }
            else{
                $fv_TemplateVars['endweek'] = '';
            }
            if(isset($this->startday)){
                $fv_TemplateVars['startday'] = ' startday="'.$this->startday.'"';
            }
            else{
                $fv_TemplateVars['startday'] = '';
            }
            if(isset($this->endday)){
                $fv_TemplateVars['endday'] = ' endday="'.$this->endday.'"';
            }
            else{
                $fv_TemplateVars['endday'] = '';    
            }
            if(isset($this->permitted)){
                $fv_TemplateVars['permitted'] = ' permitted="'.$this->permitted.'"';
            }
            else{
                $fv_TemplateVars['permitted'] = '';
            }
            if(isset($this->rel)){
                $fv_TemplateVars['rel'] = ' rel="'.$this->rel.'"';
            }
            else{
                $fv_TemplateVars['rel'] = '';
            }
            if(isset($this->target)){
                $fv_TemplateVars['target'] = ' target="'.$this->target.'"';
            }
            else{
                $fv_TemplateVars['target'] = '';
            }
            
            
            $monday = date_create('monday this week');
            $tuesday = date_create('tuesday this week');
            $wednesday = date_create('wednesday this week');
            $thursday = date_create('thursday this week');
            $friday = date_create('friday this week');
            $saturday = date_create('saturday this week');
            $sunday = date_create('sunday this week');
            

            
            if($fv_TemplateVars['dateformat'] === 'american'){
                //echo 'american'; exit();
                if(isset($this->startdate)){
                    //echo $this->startdate;
                    $str = $this->startdate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'m/d/Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('m-d-Y',$this->startdate);
                            date_format($sdate,'m-d-Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('m.d.Y',$this->startdate);
                            date_format($sdate,'m.d.Y');;
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('m d Y',$this->startdate);
                            date_format($sdate,'m d Y');
                            $now = date_create("now");
                            break;
                        }
                    }
                    //echo $mdy;
                }
                if(isset($this->enddate)){
                    //echo $this->startdate;
                    $str = $this->enddate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'m/d/Y');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('m-d-Y',$this->enddate);
                            date_format($edate,'m-d-Y');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('m.d.Y',$this->enddate);
                            date_format($edate,'m.d.Y');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('m d Y',$this->enddate);
                            date_format($edate,'m d Y');
                            break;
                        }
                    }
                    //echo $mdy;
                }
                
               // echo $date->format('m-d-Y');
            }
            elseif($fv_TemplateVars['dateformat'] === 'european'){
                //echo 'europe'; exit();
                if(isset($this->startdate)){
                    $str = $this->startdate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'d/m/Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('d-m-Y',$this->startdate);
                            date_format($sdate,'d-m-Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('d.m.Y',$this->startdate);
                            date_format($sdate,'d.m.Y');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('d m Y',$this->startdate);
                            date_format($sdate,'d m Y');
                            $now = date_create("now");
                            break;
                        }
                    }
                    //echo $mdy;
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'d/m/Y');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('d-m-Y',$this->enddate);
                            date_format($edate,'d-m-Y');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('d.m.Y',$this->enddate);
                            date_format($edate,'d.m.Y');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('d m Y',$this->enddate);
                            date_format($edate,'d m Y');
                            break;
                        }
                    }
                    //echo $mdy;
                }
               // echo $date->format('d-m-Y');
            }
            elseif($fv_TemplateVars['dateformat'] === 'chinese'){
                //echo 'chinese'; exit();
                if(isset($this->startdate)){
                    $str = $this->startdate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        
                        if($char === "/"){
                            $sdate = date_create($this->startdate);
                            date_format($sdate,'Y/m/d');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === "-"){
                            $sdate = date_create_from_format('Y-m-d',$this->startdate);
                            date_format($sdate,'Y-m-d');
                            $now = date_create("now");
                        }
                        elseif($char === "."){
                            $sdate = date_create_from_format('Y.m.d',$this->startdate);
                            date_format($sdate,'Y.m.d');
                            $now = date_create("now");
                            break;
                        }
                        elseif($char === " "){
                            $sdate = date_create_from_format('Y m d',$this->startdate);
                            date_format($sdate,'Y m d');
                            $now = date_create("now");
                            break;
                        }
                    }
                    //echo $mdy;
                }
                if(isset($this->enddate)){
                    $str = $this->enddate;
                    //echo $str;
                    $strlen = strlen($str);
                    for($i = 0; $i<=$strlen; $i++){
                        $char = substr($str,$i,1);
                        if($char === "/"){
                            $edate = date_create($this->enddate);
                            date_format($edate,'Y/m/d');
                            break;
                        }
                        elseif($char === "-"){
                            $edate = date_create_from_format('Y-m-d',$this->enddate);
                            date_format($edate,'Y-m-d');
                            break;
                        }
                        elseif($char === "."){
                            $edate = date_create_from_format('Y.m.d',$this->enddate);
                            date_format($edate,'Y.m.d');
                            break;
                        }
                        elseif($char === " "){
                            $edate = date_create_from_format('Y m d',$this->enddate);
                            date_format($edate,'Y m d');
                            break;
                        }
                    }
                }
            }
            else{
                //echo 'unix'; exit();
                $now = new Datetime("now");
                if(isset($this->startdate)){
                    $sdate = date_create($this->startdate);
                }
                if(isset($this->enddate)){
                    $edate = date_create($this->enddate);
                }
                
               // echo $gv_currenttime;
            }
            
            if(!($this->startdate)){
                if($gv_StartDate){
                    $sdate = $gv_StartDate;
                }
                else{
                    $sdate = date_create('now');
                    $now = date_create('now');
                }
            }
            if(!($this->enddate)){
                if($gv_EndDate){
                    $edate = $gv_EndDate;
                }
                else{
                    $edate = date_create('now');
                }
                
            }
            
            $interval2 = $now->diff($sdate);
            $CurrentWeek =0;
            $CurrentWeek = (int)((($interval2->days) / 7)+1);
            
            $interval3 = $now->diff($sdate);
            $CurrentDay = 0;
            $CurrentDay = (int)((($interval3->days))+1);
            
            if($now<$sdate){
                $CurrentWeek = $CurrentWeek * -1;
                $CurrentDay = $CurrentDay * -1;
            }
            
            $ifstartday = false;
            $ifendday = false;
            
            if($this->startday and $this->startweek){
                if($this->startday == '1'){
                    if($now > $monday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '2'){
                    if($now > $tuesday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '3'){
                    if($now >= $wednesday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '4'){
                    if($now >= $thursday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '5'){
                    if($now >= $friday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '6'){
                    if($now >= $saturday){
                        $ifstartday = true;
                    }
                }
                if($this->startday == '7'){
                    if($now >= $sunday){
                        $ifstartday = true;
                    }
                }
            }
            if($this->endday and $this->endweek){
                if($this->endday == '1'){
                    if($now >= $monday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '2'){    
                    if($now >= $tuesday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '3'){
                    if($now >= $wednesday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '4'){
                    if($now >= $thursday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '5'){
                    if($now >= $friday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '6'){
                    if($now >= $saturday){
                        $ifendday = true;
                        return;
                    }
                }
                if($this->endday == '7'){
                    if($now >= $sunday){
                        $ifendday = true;
                        return;
                    }
                }
            }
            
            if(!($this->startweek) and $this->startday and $this->startdate){
                if($CurrentDay >= (int)$this->startday){
                    $ifstartday = true;
                }
            }
            if(!($this->endweek) and $this->endday and $this->enddate){
                if($CurrentDay >= $this->endday){
                    $ifendday = true;
                }
            }

            $this->passes = false;
            $this->notext = false;
            if($this->showtext == "false" or $this->showtext == "no"){
                $this->notext = true;
            }
            
            if($now){
                if(isset($this->startdate)){
                    if($now < $sdate){
                        if($this->notext == true){
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.hide.tplt',$fv_TemplateVars);
                            return;
                        }
                        else{
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/noclick.begin.tplt',$fv_TemplateVars);
                            return;
                        }  
                    }
                }
                if(isset($this->enddate)){
                    if($now > $edate){
                        if($this->notext == true){
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.hide.tplt',$fv_TemplateVars);
                            return;
                        }
                        else{
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/noclick.begin.tplt',$fv_TemplateVars);
                            return;
                        } 
                    }
                }
                if(isset($this->startweek)){
                   if($CurrentWeek < $this->startweek){
                        if($this->notext == true){
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.hide.tplt',$fv_TemplateVars);
                            return;
                        }
                        else{
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/noclick.begin.tplt',$fv_TemplateVars);
                            return;
                        } 
                   }
                }
                if(isset($this->endweek)){
                    if($CurrentWeek > $this->endweek){
                        if($this->notext == true){
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.hide.tplt',$fv_TemplateVars);
                            return;
                        }
                        else{
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/noclick.begin.tplt',$fv_TemplateVars);
                            return;
                        } 
                    }
                }
                if(isset($this->startday)){
                    if($ifstartday == false){
                        if($this->notext == true){
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.hide.tplt',$fv_TemplateVars);
                            return;
                        }
                        else{
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/noclick.begin.tplt',$fv_TemplateVars);
                            return;
                        } 
                    }
                }
                if(isset($this->endday)){
                    if($ifendday == true){
                        if($this->notext == true){
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.hide.tplt',$fv_TemplateVars);
                            return;
                        }
                        else{
                            $this->echoTemplate($gv_ScheduleDirectory . 'templates/noclick.begin.tplt',$fv_TemplateVars);
                            return;
                        } 
                    }
                }
                $this->passes = true;
                $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.show.tplt',$fv_TemplateVars);
            }
            else{
                $this->passes = false;
                $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.begin.hide.tplt',$fv_TemplateVars);
            }
		}
		
        
		function end() {
            global  $gv_ScheduleDirectory;
			
		    $this->finishCache();
            if($this->passes == true){
                echo $this->tagCache;
                $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.end.tplt', array());
            }
            else{
                if($this->notext == true){
                    $this->echoTemplate($gv_ScheduleDirectory . 'templates/a.end.tplt', array());
                    return;
                }
                else{
                    echo $this->tagCache;
                    $this->echoTemplate($gv_ScheduleDirectory . 'templates/noclick.end.tplt', array());
                    return;
                }
            }

		}

	
	}
	
	
/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */
/* * * * * * * * * * * * * * Events Scheduling * * * * * * * * * * * * * * * * * */
/* We will need a database table to keep track of when scheduled actions were    */
/* last executed so that we can determine if they should be executed on this     */
/* particular page load. If any scheduled actions are executed, then their       */
/* respective records in the table should be updated appropriately.              */
/* Let's name the table molly_schedule											 */
/* -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----+----- */


// Get some base info
//$gv_ScheduleGlobals
$fv_scheduledEvents = array('hourly' => array(), 'daily' => array(), 'weekly' => array(), 'monthly' => array(), 'annually' => array());
$fv_configTable = $gv_SiteGlobals['Config']['ConfigTableName'];
$fv_queuedEvents = array();
$fv_nowUtc = date_create("now", new DateTimeZone("UTC"));
$fv_lastRun = date_create("@0", new DateTimeZone("UTC"));
$fv_getLastRun = m_FetchRecordsArray($fv_configTable, 'value', "`setting`='WebCronLastRun'");
if(count($fv_getLastRun) > 0) {
	$fv_lastRun = date_create("@" . $fv_getLastRun[0]['value'], new DateTimeZone("UTC"));
}

// Assert existence of WebCronLastRun key in global config
m_DoQuery("INSERT INTO `$fv_configTable` (`description`,`setting`,`value`,`whichpicker`) SELECT * FROM (SELECT '[DO NOT EDIT] Last run of web cron (Unix Time)','WebCronLastRun','0','none') AS tmp WHERE NOT EXISTS (SELECT * FROM `$fv_configTable` WHERE `setting`='WebCronLastRun');");

// Ingest scheduled items
foreach($gv_ScheduleGlobals as $name => $values) {
	array_push($fv_scheduledEvents[$values['Interval']], array(
		'name' => $name,
		'type' => $values['Type'],
		'source' => $values['Source'],
		'action' => $values['Action']
	));
}

// Check each type and queue if should be executed
if(date_format($fv_lastRun, "Y") != date_format($fv_nowUtc, "Y")) {
	foreach($fv_scheduledEvents['annually'] as $event) {
		array_push($fv_queuedEvents, $event);
	}
}
if(date_format($fv_lastRun, "Y-m") != date_format($fv_nowUtc, "Y-m")) {
	foreach($fv_scheduledEvents['monthly'] as $event) {
		array_push($fv_queuedEvents, $event);
	}
}
if(date_format($fv_lastRun, "Y-m-d") != date_format($fv_nowUtc, "Y-m-d")) {
	foreach($fv_scheduledEvents['daily'] as $event) {
		array_push($fv_queuedEvents, $event);
	}
}
if(date_format($fv_lastRun, "Y-m-d H") != date_format($fv_nowUtc, "Y-m-d H")) {
	foreach($fv_scheduledEvents['hourly'] as $event) {
		array_push($fv_queuedEvents, $event);
	}
}
$fv_nowUtcWeek = clone $fv_nowUtc;
date_modify($fv_nowUtcWeek, "Sunday");
$fv_lastRunWeek = clone $fv_lastRun;
date_modify($fv_lastRunWeek, "Sunday");
if(date_format($fv_lastRunWeek, "Y-m-d") != date_format($fv_nowUtcWeek, "Y-m-d")) {
	foreach($fv_scheduledEvents['weekly'] as $event) {
		array_push($fv_queuedEvents, $event);
	}
}

// Process events - no santitization since has to be hard-coded by the site's webmaster
foreach($fv_queuedEvents as $event) {
	if(strtolower($event['type']) == 'sql') {
		if(strtolower($event['source']) == 'string') {
			m_DoQuery($event['action']);
		} else if(strtolower($event['source']) == 'file') {
			m_DoQuery(file_get_contents(m_Interpolate($event['action'], $gv_Config)));
		}
	} else if(strtolower($event['type']) == 'php') {
		if(strtolower($event['source']) == 'string') {
			eval($event['action']); // dangerous but it's the spec
		} else if(strtolower($event['source']) == 'file') {
			include m_Interpolate($event['action'], $gv_Config);
		}
	}
}

// Update last run in database
$fv_nowUnix = date_format($fv_nowUtc, "U");
m_DoQuery("UPDATE `$fv_configTable` SET `value`='$fv_nowUnix' WHERE `setting`='WebCronLastRun';");
?>